Subject: Re: nicer frontend to get rebased tree?

From: Jakub Narebski <[email-masked]>
Date: Sun, 24 Aug 2008 00:49:17 +0200

Andi Kleen wrote:
> Jakub Narebski wrote:

[By the way, could you try to keep attributions? It helps when writing
 responses to know who wrote which part. TIA]

> > If you are thinking about 'linux-next', it is exception rather than
> > the rule.
> 
> No you're wrong. The majority of Linux trees I have to deal with 
> do it now and then. And I must say I also understand why 
> they want it -- they want a clean history on top of Linus' tree.
> Otherwise there is no chance to find the own changes again
> after a few thousands other merges.

Numbers? I still think that in most cases projects shouldn't rebase
published history; and if they are, they should be educated (as Linus
wrote elsewhere in the thread).
 
> > First, there isn't just _one_ way to deal with non fast-forward 
> > (rebased) branch; there are many possible workflow wrt rebasing.
> 
> I don't doubt there are a million ways to do it somehow in
> all kinds of convoluted ways. And that's exactly the problem.

_Workflows_. Not the way to deal with non fast-forward branches, not
the sequence of commands used, but the workflow, how branches are meant
to be used.

And that's three workflows which use rebase on published branches, not
million.  Perhaps they are a few more that I didn't thought about, but
I don't think that it would be _much_ more.

> The only thing I asked for was that were as a simple standard way that
> is actually documented in the main documentation and the tutorials
> and doesn't require lots of strange commands.
> 
> Not more not less. Right now that's not there as I know
> from my own experience.
> 
> Maybe for you people who spend days thinking about git and
> hacking it these ways are all obvious, but for someone like
> me who just wants to use the tool it's definitely not easy
> to do currently.

There is "simple standard way", although it might be not obvious to
somebody who is only beginner git user.  And the problem is that
for "us people" it is _obvious_, so it is not documented.  Documentation
is usually best done, or at least best started by people who have
freshness enough to know what beginners might stumble on, what people
new to git might have problems with, while having enough information
to actually write good, correct, exhaustive documentation.

And the simple standard way is fetch+checkout (detaching checkout),
at least for linux-next repository/project workflow.

> Anyways I'll shut up on this now because it sounds like
> you people are not interested in improving the tool for 
> non power users. 

Why don't you send patch improving documentation (or command messages)
then, eh?

-- 
Jakub Narebski
Poland